#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "rpc.h"
#include "client-lib.h"

int	verbose = 0;

void	usage(void)
{
	fprintf(stderr,"Usage: net_redir -s PORT@HOST -d 3 -- client2\n");
}

/* used with net_redir; assumes that descriptor 3 is the network */
int main(int	ac,
	 char	**av)
{
	int			which;
	int			i0, i1, i2;
	double			d0, d1;
	double			outd;

	struct srss_state	state;

	int			opt,rv;

	while ((opt = getopt(ac,av,"v")) != EOF) switch (opt) {
	case 'v':	verbose++;		break;
	default:	usage(); exit(0);	break;
	}

	srss_client_init(&state,3);
	for (;;) {
		/* there should be error checking on the scanf etc */
		do {
			printf("which rpc (-1 to exit)? ");
			scanf("%d",&which);
			if (which == -1) return 0;
		} while ((which < 0 || which > 1) && (puts("bad rpc num"), 1));
		printf("i0: "); scanf("%d",&i0);
		printf("i1: "); scanf("%d",&i1);
		if (which == 0) {
			printf("i2: "); scanf("%d",&i2);
		}
		printf("d0: "); scanf("%lf",&d0);
		printf("d1: "); scanf("%lf",&d1);
	
		if (verbose) printf("performing RPC\n");
		if (which == 0) {
			rv = rpc_hndlr0(&state,&outd,i0,d0,i1,d1,i2);
		} else {
			rv = rpc_hndlr1(&state,&outd,i0,d0,i1,d1);
		}

		if (rv) {
			printf("reply value: %f\n",outd);
		} else {
			printf("bad reply\n");
		}
	}

	return 0;
}
